Subject: Re: The git newbie experience

From: Shawn Pearce <[email-masked]>
Date: Mon, 15 May 2006 01:27:28 -0400

Tommi Virtanen <[email-masked]> wrote:
> Junio C Hamano wrote:
[snip]
> > - Jack stashes away what he has been working on and cleans up
> >   his mess.
> > 
> >   git diff >P.diff
> >   git checkout HEAD A B C
> ...
> > - Jack then reapplies what he stashed away with "git apply P.diff"
> >   and keeps working.
> > 
> > Maybe "git stash" command that does "git diff --full-index" with
> > some frills, and "git unstash" command which does an equivalent
> > of "git am -3" would help this workflow (bare "git apply" does
> > not do the three-way merge like am does).
> 
> Oh, I'd love to have a quick stash, that's what we actually ended up
> doing a lot. Although I'd rather see a real implementation use a branch
> and not just a diff file, but.. yes please.
> 
> Although, "git stash" and "git unstash" are yet another command to add
> to the newbie set, and I just complained about the size of the set ;)

This is perhaps one area where SVN's user interface is actually nice.
SVN's equiv. of stash is making a copy of your working directory into
the repository; something that is rather simple to do for the user.

What about "git commit -b foo -a" to commit the current working
directory to branch 'foo'?

Then restoring is a pull of foo ("git pull . foo"), but that
intermediate commit is now part of the repository history.  And "git
commit -a" doesn't automatically add extra/other files to the
repository and it probably should in the case of a "stash".

-- 
Shawn.